﻿import mx.remoting.Service;
import mx.rpc.RelayResponder;
import mx.rpc.FaultEvent;
import mx.rpc.ResultEvent;
class AMFPHP {
	private var capturaRespuesta:RelayResponder;
	private var Servicio:Service;
	private var Llamadas:Array;
	public var eventos:Object;
	function AMFPHP(slGateway:String, slServicio:String) {
		capturaRespuesta = new RelayResponder(this, "onRespuesta", "onError");
		Servicio = new Service(slGateway, null, slServicio, null, capturaRespuesta);
		Llamadas = new Array();
		eventos = new Object();
	}
	function onRespuesta(data) {
		var slFuncion:String;
		slFuncion = Llamadas[0].funcion;
		slFuncion = slFuncion.substr(0, 1).toUpperCase()+slFuncion.substr(1, slFuncion.length-1);
		eventos["on"+slFuncion].apply(eventos.Padre, [data.result]);
		Llamadas.shift();
		if (Llamadas.length>0) {
			procesa(Llamadas[0].funcion, Llamadas[0].parametros, true);
		}
	}
	function onError(fault):Void {
		trace("Error en el Metodo: "+Llamadas[0].funcion);
		trace(fault.fault.faultstring);
	}
	function procesa(funcion, parametros, Automatico) {
		if (Llamadas.length == 0 or Automatico) {
			Servicio[funcion].apply(this, parametros);
		}
		if (!Automatico) {
			var miObjeto = new Object();
			miObjeto.funcion = funcion;
			miObjeto.parametros = parametros;
			Llamadas.push(miObjeto);
		}
	}
}